<?php

namespace BitGoblin\Goliath\Models;

use Illuminate\Database\Eloquent\Model;
use League\CommonMark\CommonMarkConverter;

class Ticket extends Model {

  protected $fillable = [
    'title',
    'body',
    'severity',
    'due_at',
  ];

  public function render(): string {
    $converter = new CommonMarkConverter([
      'html_input' => 'strip',
      'allow_unsafe_links' => false,
    ]);

    return $converter->convert($this->body);
  }

  public function comments() {
    return $this->hasMany(Comment::class);
  }

  public function formatCreatedAt(): string {
    return date_format(date_create($this->created_at), "F jS\\, Y \\a\\t g:i:s a");
  }

  public function formatUpdatedAt(): string {
    return date_format(date_create($this->updated_at), "F jS\\, Y \\a\\t g:i:s a");
  }

}
